/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { Headers, Request, Response, BaseApiCore, ErrorStrategyOptionType, FetchOptions } from '@managed-api/commons-core';
import { CommonError, AdditionalErrorTypes, ErrorStrategyHandlers, ErrorStrategyOption } from './errorStrategy';
import { ErrorStrategyBuilder } from './builders/errorStrategy';
export interface GenericAppApiCoreOptions extends ErrorStrategyOption {
}
export declare abstract class GenericAppApiCore extends BaseApiCore {
    private options?;
    constructor(options?: GenericAppApiCoreOptions | undefined);
    setGlobalErrorStrategy(errorStrategy: ErrorStrategyOptionType<CommonError, AdditionalErrorTypes, ErrorStrategyHandlers, ErrorStrategyBuilder>): void;
    fetch<T = any>(resource: string | Request, options?: FetchOptions): Promise<Response<T>>;
    private constructHeaders;
    protected buildResponse(url: string, status: number, statusText: string, headers: Headers, body?: string | ArrayBuffer): Response<any>;
    private getGlobalErrorStrategy;
}
//# sourceMappingURL=index.d.ts.map